--Copyright ©2020, Wirepath Home Systems, LLC. All rights reserved.

epi_data = {}
epi_data._VERSION = "epi_data 1.0.0"

EQ_COUNT = 0

function epi_data.Init(outputCount, inputCount)
   newEpiData = {}
   newEpiData._VERSION = epi_data._VERSION
   newEpiData.deviceFirmware = ""
   newEpiData.DHCP = true
   newEpiData.IPADDRESS = ""
   newEpiData.GATEWAYADDRESS = ""
   newEpiData.DNSADDRESS = ""
   newEpiData.MASKADDRESS = ""
   newEpiData.disableAudioSense = false
   newEpiData.ampName = ""
   newEpiData.userName = ""
   newEpiData.password = ""
   currentInput = "HDMI1"


   newEpiData.outputCount = outputCount
   newEpiData.inputCount = inputCount
   newEpiData.inputs = {}
   newEpiData.outputs = {}

   for i = 1, inputCount do
      input = {}
      epi_data.InitInput(input, i)
      table.insert(newEpiData.inputs, input)
   end

   for i = 1, outputCount do
      out = {}
      epi_data.InitOutput(out, i)
      table.insert(newEpiData.outputs, out)
   end
   return newEpiData
end

function epi_data.SetupEqBand(eqBand)
   for i = 1, EQ_COUNT do
      band = {}
      epi_data.InitEqBand(band, i)
      table.insert(eqBand, band)
      i = i +1
   end
 end

function epi_data.InitInput(input, index)
   input.index = index
   input.name = ""
   input.soundMode = 0
   input.enabled = 1
   input.maxVolume = 80
   input.inputGain = 0
end

 
function epi_data.InitOutput(output, index)
   output.index = index
   output.name = ""
   output.eqSelectedIndex = 0
   output.enabled = false
     
   output.outputLoudnessEnabled = false
   output.monoSumEnabled = false
   output.eqBands = {}
   epi_data.SetupEqBand(output.eqBands)
   output.eqBandsCustom1 = {}
   epi_data.SetupEqBand(output.eqBandsCustom1)
   output.eqBandsCustom2 = {}
   epi_data.SetupEqBand(output.eqBandsCustom2)
   output.eqBandsCustom3 = {}
   epi_data.SetupEqBand(output.eqBandsCustom3)
   output.eqBandsCustom4 = {}
   epi_data.SetupEqBand(output.eqBandsCustom4)
   output.eqBandsCustom5 = {}
   epi_data.SetupEqBand(output.eqBandsCustom5)
   output.customEqNames = {}
end

function epi_data.InitEqBand(band, index)
   band.index = index
   if (index == 1) then band.freq = 5 end
   if (index == 2) then band.freq = 11 end
   if (index == 3) then band.freq = 17 end
   if (index == 4) then band.freq = 23 end
   if (index == 5) then band.freq = 30 end
   band.gain = 0
   band.Q = 2
end

