--------------------------------------------------------------------------------------------
--	ServiceLocator.lua
--  
--  Copyright 2014 Control4 Corporation. All rights reserved.
--
--  Creates a global way to locate services within the driver. 
--  Call addService to add a table as a service. Services can then be used by calling
--  ServiceLocator.ServiceName
--------------------------------------------------------------------------------------------

ServiceLocator = {
	_services = {}
}
	
function ServiceLocator:addService(serviceName, serviceObj)
	self._services[serviceName] = serviceObj
end

ServiceLocator.mt = {}
ServiceLocator.mt.__index = ServiceLocator._services
ServiceLocator.mt.__metatable = "Protected"
setmetatable(ServiceLocator, ServiceLocator.mt)

function __ServiceLocator_tests()
	ServiceLocator:addService("test1", {test = function() return 1 end})
	ServiceLocator:addService("test2", {test = function() return 2 end})
	ServiceLocator:addService("test3", {test = function() return 3 end})
	ServiceLocator:addService("test4", {test = function() return 4 end})
	ServiceLocator:addService("test5", {test = function() return 5 end})

	assert(ServiceLocator.test1:test() == 1)
	assert(ServiceLocator.test2:test() == 2)
	assert(ServiceLocator.test3:test() == 3)
	assert(ServiceLocator.test4:test() == 4)
	assert(ServiceLocator.test5:test() == 5)
end